<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method = "xml" encoding ="UTF-8" omit-xml-declaration = "yes"/>
	<xsl:variable name="foo">foo</xsl:variable>
	<xsl:variable name="default">xsl:default</xsl:variable>


	<xsl:decimal-format name="foo" 
		decimal-separator="d" 
		grouping-separator="g" 
		percent="p"
		per-mille="m" 
		zero-digit="2" 
		digit="i" 
		pattern-separator="|" 
		infinity="~" 
		NaN=" nan " 
		minus-sign="+" 
	/>
	<xsl:decimal-format name="xsl:default" /> 
	<xsl:decimal-format name="default" /> 
	
	<xsl:template match="/">
	<wrapper>
	<test name="non-default">
		infinity =<xsl:value-of select="format-number(1 div 0, '', $foo)"/>
		infinity =<xsl:value-of select="format-number(-1 div 0, '', $foo)"/>
		decimal-separator =<xsl:value-of select="format-number(1.1, 'idi', 'foo')"/>
		grouping-separator =<xsl:value-of select="format-number(1000111000.1, 'iiiiiiiiiidiiiiiiiii', $foo)" />
		percent =<xsl:value-of select="format-number(1 div 1, 'iip', $foo)" />
		per-mille =<xsl:value-of select="format-number(1000, 'iiigiiigiiidiiigm', $foo)" />
		pattern-separator =<xsl:value-of select="format-number(2-3.56, 'iidii', $foo)" />
		nan =<xsl:value-of select="format-number(0 div 0, 'iidii', $foo)" />
	</test>
	<p/>
	<test name="default">
		infinity =<xsl:value-of select="format-number(1 div 0, '', $default)"/>
		infinity =<xsl:value-of select="format-number(-1 div 0, '', $default)"/>
		decimal-separator =<xsl:value-of select="format-number(1.1, '', 'xsl:default')"/>
		grouping-separator =<xsl:value-of select="format-number(1000111000.1, '#,###.###', $default)" />
		percent =<xsl:value-of select="format-number(1 div 1, '#%', $default)" />
		per-mille =<xsl:value-of select="format-number(1, '#,000.00&#x2030;', $default)" />
		pattern-separator =<xsl:value-of select="format-number(2-3.56, 'iidii', $default)" />
		nan =<xsl:value-of select="format-number(0 div 0, 'iidii', $default)" />
	</test>
	<p/>
	<test name="default :  saxom output different from msxml.">
		per-mille =<xsl:value-of select="format-number(1, '#,000.00&#x2030;', 'default')" />
	</test>
	</wrapper>
	</xsl:template>


</xsl:stylesheet>

