<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method = "xml" encoding ="UTF-8" omit-xml-declaration = "yes"/>
<xsl:preserve-space elements="*" />
<xsl:template match="/">
<xml>
<xsl:apply-templates/>
</xml>
</xsl:template>

<!-- Templates for each node type follows.-->
  
<xsl:template match="*">
        <xsl:element name="element">
		<xsl:attribute name = "name"><xsl:value-of select="local-name()"/></xsl:attribute>
		<xsl:attribute name="namespace-uri"><xsl:value-of select="namespace-uri()"/></xsl:attribute>
		<xsl:for-each select = "namespace::*">
		<xsl:call-template name="namespace"/>	
		</xsl:for-each>
		<xsl:apply-templates select = "@*"/>
		<!--xsl:apply-templates select = "*"/-->
		<xsl:apply-templates/>
        </xsl:element>
</xsl:template>
<xsl:template match="@*">
        <xsl:element name="attribute">
		<xsl:attribute name = "name"><xsl:value-of select="local-name()"/></xsl:attribute>
		<xsl:attribute name="namespace-uri"><xsl:value-of select="namespace-uri()"/></xsl:attribute>
		<xsl:value-of select = "."/>
        </xsl:element>
</xsl:template>
<xsl:template name="namespace">
        <xsl:element name="namespace" >
		<xsl:value-of select = "."/>		
        </xsl:element>
</xsl:template>
<xsl:template match="processing-instruction()" xml:space="preserve">
        <xsl:element name="pi"><xsl:attribute name = "name"><xsl:value-of select = "name()"/></xsl:attribute>
		<xsl:value-of select = "."/>
        </xsl:element>
</xsl:template>
<!-- Template for text nodes -->
<xsl:template match="text()">
	<xsl:element name="text" xml:space="preserve">
  		<xsl:value-of select = "."/>
	</xsl:element>
</xsl:template>
  
<!-- Template for comment nodes -->
<xsl:template match="comment()" xml:space="preserve">
        <xsl:element name="comment" >
                <xsl:value-of select = "."/> 
        </xsl:element>
</xsl:template>

</xsl:stylesheet>