// script makes infoset files for tests driven by OASIS control file

var control = new ActiveXObject("MSXML2.DOMDocument");
var dom = new ActiveXObject("MSXML2.DOMDocument");
var xsl = new ActiveXObject("MSXML2.DOMDocument");
var fso = new ActiveXObject("Scripting.FileSystemObject");
var infosetgen = new ActiveXObject("MSXML2.DOMDocument");
infosetgen.load("infosetgen.xsl");
control.load("control.xml");
var varlist = control.selectNodes("//test-case");
for(i = 0; i < varlist.length; i++) {
	inpname = varlist(i).selectSingleNode("scenario/input-file").text;
	xslname  = varlist(i).selectSingleNode("source").text;
	outname = varlist(i).selectSingleNode("scenario/i-output-file").text;
	iinpname = varlist(i).selectSingleNode("scenario/i-input-file").text;
	method = varlist(i).selectSingleNode("scenario/@compare").nodeValue;
	
	res = dom.load(inpname);
	if (!res) {
		WScript.Echo("Iter:"+ i+ ", Not wellformed input xml" + inpname);
		continue;
	}

	if (!MakeXMLInfoset(dom, iinpname) ) {
		WScript.Echo("Failed to generate infoset for input file" + inpname);
	}

	if (varlist(i).selectSingleNode("scenario/@operation").nodeValue != "error") {
		dom.load(inpname)
		xsl.load(xslname)
		result = dom.transformNode(xsl)
				
		if ( method == "XML") {
			res = dom.loadXML(result)
			if (!res) {
				WScript.Echo("Iter:"+ i+ ",Not wellformed result of transform" + inpname);
				continue;
			}
			res = MakeXMLInfoset(dom, outname);	
		}
		else if ( method == "Text") {
			res = MakeTextInfoset(result, outname);
		}
		else if ( method == "HTML") {
			res = MakeHTMLInfoset(result, outname);//not implemented
		}
		if (!res) {
			WScript.Echo("Iter:"+ i+ ",Not able to make infoset for output" + outname);	
		}
		
	}
	else { //write empty wrappers
		if (method == "XML") {
			dom.loadXML("<xml/>");
		}
		else if(method == "Text") {
			dom.loadXML("<text/>");
		}
		else if(method == "HTML") {
			dom.loadXML("<html/>");
		}
		dom.save(outname);
	}
	

}
WScript.Echo("Finished!");

function MakeXMLInfoset(dom, infosetname) { 
	//getting infoset for input file, return false if not successfull
	//since you can't pass objects, we have to use global variable for input DOM
	var test = new ActiveXObject("MSXML2.DOMDocument");
	try {
		res = dom.transformNode(infosetgen);
		success = test.loadXML(res);
		test.save(infosetname);
	}
	catch(ex) {
		WScript.Echo(ex.description);
		return false;
	}
	return success;
}

function MakeTextInfoset(text, infosetname) {
	//getting infoset for input file, return false if not successfull
	var test = new ActiveXObject("MSXML2.DOMDocument");
	//changing all new-line characters to </line><line> pairs, OS specific code
	text = strchange(text, "\r\n", "\n");
	text = strchange(text, "\r", "\n");
	text = strchange(text, "\n", "</line><line>");
	text = "<text><line>" + text + "</line></text>";
	try {
		success = test.loadXML(text);
		test.save(infosetname);
	}
	catch(ex) {
		return false;
	}
	return success;
}

function strchange(src,substr1, substr2) {
	ipos = src.indexOf(substr1, 0);
	while(ipos >= 0) {
		start = "";
		if (ipos > 0) start = src.substr(0, ipos); 
		src = start + substr2 + src.substr(ipos + substr1.length);
		ipos = src.indexOf(substr1, ipos + substr2.length)
	}
	return src;
}


