var  control = new ActiveXObject("MSXML2.DOMDocument");
var test =  new ActiveXObject("MSXML2.DOMDocument");
var xsl =  new ActiveXObject("MSXML2.DOMDocument");
var expect =  new ActiveXObject("MSXML2.DOMDocument");
var fso =  new ActiveXObject("Scripting.FileSystemObject");
var infoset  = new ActiveXObject("MSXML2.DOMDocument");
var result;
var resultname;




infoset.load("infosetgen.xsl");
control.load("control.xml");
suitename = control.selectSingleNode("//test-suite/@name").nodeValue;
resultname= suitename + "-res.xml";
result = fso.OpenTextFile(resultname, 2, true);
result.write("<test-suite-result name='" + suitename + "'> \r\n");
result.close();

var varlist = control.selectNodes("//test-case");
for(i = 0; i < varlist.length; i++) { 
	var success;

	id = varlist(i).selectSingleNode("identifier").text
	inpname = varlist(i).selectSingleNode("scenario/input-file").text;
	xslname  = varlist(i).selectSingleNode("source").text;
	outname = varlist(i).selectSingleNode("scenario/i-output-file").text;
	
	expect.load(outname);	
	
	//WScript.Echo(expect.documentElement.nodeName);
	
	
	if (expect.documentElement.nodeName == "xml") {
		success = testXML(inpname, xslname, outname);		
	}
	
	if (expect.documentElement.nodeName == "text") {
		success = testText(inpname, xslname, outname);
	}
	
	expect_success = (varlist(i).selectSingleNode("scenario/@operation").nodeValue != "error");
	
	if (success !=  expect_success) {
		WriteResult(id, "failed");
	}
	else {
		WriteResult(id, "passed");
	}
	
	
}
result = fso.OpenTextFile(resultname,8,true);
result.write("</test-suite-result> \r\n");
result.close();
WScript.Echo("Test Finished!");

function testXML(inpname, xslname, outname) {
	test.load(inpname);
	xsl.load(xslname);
	expect.load(outname);
	try {
		res = test.transformNode(xsl);
	} catch(ex) {		
		return false;//failed to do transform
	}
	success = test.loadXML(res);
	if (!success) {
	   	//having invalid xml
		return false;
	}
	
	//making i-transform
	res = test.transformNode(infoset);
	success = test.loadXML(res);
	if (!success) {
	   	//having invalid xml as a result of transform - most likely bug in transform
		return false;
	}
	//comparing normalized transform results
	if (expect.xml == test.xml) {
		return true; //match		
	}
	else {
		return false; //do not match	
	}
}



function testText(inpname, xslname, outname) {
	//getting infoset for input file, return false if not successfull
	var test = new ActiveXObject("MSXML2.DOMDocument");
	//changing all new-line characters to </line><line> pairs, OS specific code
	if (!test.load(inpname)) {
		return false;
	}
	if (!xsl.load(xslname)) {
		return false;
	}
	expect.load(outname);
	//making transform and infoset if it.
	try {
		text = test.transformNode(xsl);
	} catch(ex) {		
		return false;//failed to do transform
	}
	text = strchange(text, "\r\n", "\n");
	text = strchange(text, "\r", "\n");
	text = strchange(text, "\n", "</line><line>");
	text = "<text><line>" + text + "</line></text>";
	success = test.loadXML(text);
	
	if (!success) {
	   	//having invalid xml as a result of transform - most likely bug in transform
		return false;
	}
	if (expect.xml == test.xml) {
		return true; //match		
	}
	else {
		return false; //do not match	
	}
	
}

function strchange(src,substr1, substr2) {
	ipos = src.indexOf(substr1, 0);
	while(ipos >= 0) {
		start = "";
		if (ipos > 0) start = src.substr(0, ipos); 
		src = start + substr2 + src.substr(ipos + substr1.length);
		ipos = src.indexOf(substr1, ipos + substr2.length)
	}
	return src;
}



function WriteResult(id, res) {
	result = fso.OpenTextFile(resultname,8,true) //append
	result.write("<test-case> \r\n" +		
		     "   <identifier>" + id + "</identifier> \r\n" +
		     "   <result>" + res + "</result> \r\n" +
		     "</test-case> \r\n");
	result.close();
}

